variables:
  DIGITAL_REFERENCE:
    value:  "https://gitlab.com/TIBHannover/sc3-project/robot-ontology-merge-test/-/raw/master/DigitalReference.ttl"
    description: "Digital reference " # makes this variable appear on the Run Pipeline form
  ONTOLOGY_TO_MERGE: 
    value:  ""
    description: "Ontology to merge " # makes this variable appear on the Run Pipeline form
  COMMIT_MESSAGE: 
    value:  "robot merge two ontlogies"
    description: "Give a commit message (default will be the pre-filled message )"

image: maven:3.6-jdk-11

stages:          # List of stages for jobs, and their order of execution
  - build
  - merge
  - push

build:       # This job runs in the build stage, which runs first.
  stage: build 
  before_script:
    - apt-get update
    - apt-get install git
  script:
    - echo "Clone Robot project"
    - git clone https://github.com/ontodev/robot.git robotOnto
    - cd robotOnto/
    - mvn clean package
  artifacts:
    paths:
      - ./robotOnto/bin/robot.jar


merge:
  stage: merge
  dependencies:
    - build
  before_script:
    - apt-get update
    - apt-get install wget 
  script:
    # - wget -O DigitalReference.ttl https://gitlab.com/TIBHannover/sc3-project/robot-ontology-merge-test/-/raw/master/DigitalReference.ttl 
    - wget -O DigitalReference.ttl  $DIGITAL_REFERENCE
    # - wget -O ontologyToMerge.ttl https://raw.githubusercontent.com/w3c/sdw/gh-pages/time/rdf/time.ttl 
    - wget -O ontologyToMerge.ttl  $ONTOLOGY_TO_MERGE
    - ls -al
    - java -jar robotOnto/bin/robot.jar merge --input DigitalReference.ttl --input ontologyToMerge.ttl --output mergedOntology.ttl
    - java -jar robotOnto/bin/robot.jar diff --left DigitalReference.ttl --right mergedOntology.ttl --output difference.html --format html
  artifacts:
    paths:
      - mergedOntology.ttl
      - difference.html

push:
  stage: push
  dependencies:
    - merge
  before_script:
    - apt-get update
    - apt-get install git
  script:
    - git config --global user.name "${GIT_ACCESS_USER_NAME}"
    - git config --global user.email "tgfawad@gmail.com"
    - git clone https://${GIT_ACCESS_USER_NAME}:${GIT_ACCESS_TOKEN}@gitlab.com/TIBHannover/sc3-project/digital-refererence-fork.git
    - cd digital-refererence-fork/
    - name=$(date +"%Hh%Mm%d%b%y")
    - git checkout -b $name
    - git push --set-upstream origin $name
    - cp ../mergedOntology.ttl Ontologies/
    - cp ../difference.html Ontologies/    
    - git add .
    - git commit -m "${COMMIT_MESSAGE}"
    - git push origin